define(
    [
        'Magento_Checkout/js/model/quote',
        'jquery',
        'Magento_Checkout/js/view/payment/default',
        'Magento_Checkout/js/action/set-billing-address',
        'Verifone_Hosted/js/action/set-payment-method',
        'Magento_Checkout/js/action/select-payment-method',
        'Magento_Checkout/js/model/payment/additional-validators',
        'Magento_Checkout/js/model/full-screen-loader',
        'domReady!' // awaits for DOM to be loaded
    ],
    function (quote, $, Component, setBillingAddressAction, setPaymentMethodAction, selectPaymentMethodAction, additionalValidators, fullScreenLoader) {
        'use strict';
        return Component.extend({
            defaults: {
                template: 'Verifone_Hosted/payment/verifone_hosted'
            },

            continueToVerifone: function (data, event) {
                event.preventDefault();
                event.stopPropagation();
                fullScreenLoader.startLoader();
                let settings = window.checkoutConfig.payment.verifone_hosted,
                    msg = document.getElementById('validation-message');

                if (this.validate() && additionalValidators.validate()) {
                    this.selectPaymentMethod();
                    var setBillingInfo = setBillingAddressAction();
                    setBillingInfo.done(function() {
                        let url = settings.redirectUrl;
                        $.ajax({
                            showLoader: true,
                            url: url,
                            type: 'get',
                            context: this,
                            data: {isAjax: 1,email: quote.guestEmail},
                            dataType: 'json',
                            success: function (response, data) {
                                fullScreenLoader.stopLoader();
                                if (response.result === "success") {
                                    if (response.method === "iframe") {
                                        var appendTo = $('#actions_toolbar');
                                        $('<div id="payment_form_container_iframe"></div>').appendTo(appendTo);
                                        $('#continue_verifone').remove();

                                        function loadIframe(src, containerId) {
                                            var script = document.createElement('script');
                                            script.src = src;
                                            script.async = true;
                                            document.getElementById(containerId).append(script);
                                        }

                                        loadIframe(
                                            response.url,
                                            'payment_form_container_iframe'
                                        );
                                        setTimeout(function() {
                                            $('iframe').css("outline","none");
                                            $('iframe').css("border","none");
                                        }, 1000);
                                    } else if (typeof response.redirect !== "undefined") {
                                        window.location.href = response.redirect;
                                    }
                                }
                            },
                            error: function (response, data) {
                                alert('An error occurred. Try again!');
                            },
                            complete: function (response) {
                                fullScreenLoader.stopLoader();
                            }
                         });
                        setPaymentMethodAction();
                    });
                    return false;
                }
            },
            isShowLegend: function () {
                return true;
            }
        });
    });
